image: ubuntu:latest
variables:
  DEBIAN_FRONTEND: noninteractive
stages:
  - build
  - test
  - deploy

build-newsletter-site:
  stage: build
  before_script:
    - apt-get update && apt-get install -y jq bash coreutils git python3 python3-pip python3-venv make
    - python3 -m venv venv
    - source venv/bin/activate
    - pip install --upgrade pip
    - pip install jinja2-cli
  script:
    - source venv/bin/activate
    - make all
    # Finde den neuesten Ordner im Verzeichnis ./public und speichere ihn in einer Variable
    - latest_dir=$(find ./public/ -mindepth 1 -maxdepth 1 -type d -printf '%T@ %p\n' | sort -n | tail -1 | cut -d' ' -f2)
    - echo "Newest directory is:$latest_dir"
    - tar -czf public.tar.gz "$latest_dir"
  artifacts:
    paths:
      - "public.tar.gz"
    expire_in: 1 hour


pages:
  stage: deploy
  needs: ["build-newsletter-site"]
  script:
    - tar -xzf public.tar.gz
    - echo "Publishing contents of public/"
  artifacts:
    paths:
      - "./public/"
    expire_in: 1 hour
  only:
    - main

caprover:
  stage: deploy
  before_script:
    - apt-get update && apt-get install -y curl
  script:
    - echo "Triggering CapRover webhook..."
    - curl -v -X POST "${CAPROVER_WEBHOOK_URL}"
  only:
    - main